/*************** Start_Gadget ****************/

struct Gadget Start_Gadget =
    {
	NULL,
	280, 11, 80, 40
	GADGHCOMP,
	RELVERIFY,
	BOOLGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	17,
	NULL
    };

/*************** Save_Gadget ****************/

struct Gadget Save_Gadget =
    {
	&Start_Gadget,
	280, 52, 80, 40
	GADGHCOMP,
	RELVERIFY,
	BOOLGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	19,
	NULL
    };

/*************** Down_Gadget ****************/

__chip USHORT Down_Data[] =
    {
	0x0f00, 0x0f00, 0x0f00, 0x0f00, 0x0f00, 0xfff0, 0x7fe0, 0x3fc0,
	0x1f80, 0x0f00, 0x0600
    };

struct Image Down_ImageB =
    {
	0, 0,
	12, 11, 1,
	Down_Data,
	0x2, 0x0,
	NULL
    };

struct Image Down_ImageA =
    {
	0, 0,
	12, 11, 1,
	Down_Data,
	0x1, 0x0,
	NULL
    };

struct Gadget Down_Gadget =
    {
	&Save_Gadget,
	12, 154, 12, 11,
	GADGHCOMP | GADGIMAGE,
	RELVERIFY,
	BOOLGADGET,
	&Down_ImageA,
	&Down_ImageB,
	NULL,
	NULL,
	NULL,
	16,
	NULL
    };

/*************** Up_Gadget ****************/

__chip USHORT Up_Data[] =
    {
	0x0600, 0x0f00, 0x1f80, 0x3fc0, 0x7fe0, 0xfff0, 0x0f00, 0x0f00,
	0x0f00, 0x0f00, 0x0f00
    };

struct Image Up_ImageB =
    {
	0, 0,
	12, 11, 1,
	Up_Data,
	0x2, 0x0,
	NULL
    };

struct Image Up_ImageA =
    {
	0, 0,
	12, 11, 1,
	Up_Data,
	0x1, 0x0,
	NULL
    };

struct Gadget Up_Gadget =
    {
	&Down_Gadget,
	12, 141, 12, 11,
	GADGHCOMP | GADGIMAGE,
	RELVERIFY,
	BOOLGADGET,
	&Up_ImageA,
	&Up_ImageB,
	NULL,
	NULL,
	NULL,
	15,
	NULL
    };

/*************** Use_Gadget ****************/

struct Gadget Use_Gadget =
    {
	&Up_Gadget,
	220, 124, 64, 12,
	GADGHCOMP,
	RELVERIFY,
	BOOLGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	14,
	NULL
    };

/*************** Del_Gadget ****************/

struct Gadget Del_Gadget =
    {
	&Use_Gadget,
	150, 124, 64, 12,
	GADGHCOMP,
	RELVERIFY,
	BOOLGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	13,
	NULL
    };

/*************** Add_Gadget ****************/

struct Gadget Add_Gadget =
    {
	&Del_Gadget,
	80, 124, 64, 12,
	GADGHCOMP,
	RELVERIFY,
	BOOLGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	12,
	NULL
    };

/*************** SaveLib_Gadget ****************/

struct Gadget SaveLib_Gadget =
    {
	&Add_Gadget,
	10, 124, 64, 12,
	GADGHCOMP,
	RELVERIFY,
	BOOLGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	11,
	NULL
    };

/*************** Name_Gadget ****************/

char Name_Buffer[40] = "Standart";
char Name_Undo[40];

struct StringInfo Name_StringInfo =
    {
	Name_Buffer,
	Name_Undo,
	0, 40, 0,
	0, 0, 0, 0, 0,
	NULL, NULL, NULL
    };

struct Gadget Name_Gadget =
    {
	&SaveLib_Gadget,
	66, 114, 208, 8,
	GADGHCOMP,
	RELVERIFY,
	STRGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	&Name_StringInfo,
	10,
	NULL
    };

/*************** Generations_Gadget ****************/

char Generations_Buffer[4] = "3";
char Generations_Undo[4];

struct StringInfo Generations_StringInfo =
    {
	Generations_Buffer,
	Generations_Undo,
	0, 4, 0,
	0, 0, 0, 0, 0,
	NULL, NULL, NULL
    };

struct Gadget Generations_Gadget =
    {
	&Name_Gadget,
	122, 97, 40, 8,
	GADGHCOMP,
	RELVERIFY,
	STRGADGET | LONGINT,
	NULL,
	NULL,
	NULL,
	NULL,
	&Generations_StringInfo,
	9,
	NULL
    };

/*************** AngleEnd_Gadget ****************/

char AngleEnd_Buffer[5] = "20";
char AngleEnd_Undo[5];

struct StringInfo AngleEnd_StringInfo =
    {
	AngleEnd_Buffer,
	AngleEnd_Undo,
	0, 5, 0,
	0, 0, 0, 0, 0,
	NULL, NULL, NULL
    };

struct Gadget AngleEnd_Gadget =
    {
	&Generations_Gadget,
	192, 85, 40, 8,
	GADGHCOMP,
	RELVERIFY,
	STRGADGET | LONGINT,
	NULL,
	NULL,
	NULL,
	NULL,
	&AngleEnd_StringInfo,
	8,
	NULL
    };

/*************** AngleStart_Gadget ****************/

char AngleStart_Buffer[5] = "5";
char AngleStart_Undo[5];

struct StringInfo AngleStart_StringInfo =
    {
	AngleStart_Buffer,
	AngleStart_Undo,
	0, 5, 0,
	0, 0, 0, 0, 0,
	NULL, NULL, NULL
    };

struct Gadget AngleStart_Gadget =
    {
	&AngleEnd_Gadget,
	122, 85, 40, 8,
	GADGHCOMP,
	RELVERIFY,
	STRGADGET | LONGINT,
	NULL,
	NULL,
	NULL,
	NULL,
	&AngleStart_StringInfo,
	7,
	NULL
    };

/*************** Rate_Gadget ****************/

char Rate_Buffer[4] = "95";
char Rate_Undo[4];

struct StringInfo Rate_StringInfo =
    {
	Rate_Buffer,
	Rate_Undo,
	0, 4, 0,
	0, 0, 0, 0, 0,
	NULL, NULL, NULL
    };

struct Gadget Rate_Gadget =
    {
	&AngleStart_Gadget,
	234, 73, 40, 8,
	GADGHCOMP,
	RELVERIFY,
	STRGADGET | LONGINT,
	NULL,
	NULL,
	NULL,
	NULL,
	&Rate_StringInfo,
	18,
	NULL
    };

/*************** Size_Gadget ****************/

char Size_Buffer[5] = "20";
char Size_Undo[5];

struct StringInfo Size_StringInfo =
    {
	Size_Buffer,
	Size_Undo,
	0, 5, 0,
	0, 0, 0, 0, 0,
	NULL, NULL, NULL
    };

struct Gadget Size_Gadget =
    {
	&Rate_Gadget,
	122, 73, 40, 8,
	GADGHCOMP,
	RELVERIFY,
	STRGADGET | LONGINT,
	NULL,
	NULL,
	NULL,
	NULL,
	&Size_StringInfo,
	6,
	NULL
    };

/*************** Three_Gadget ****************/

char Three_Buffer[40] = "3";
char Three_Undo[40];

struct StringInfo Three_StringInfo =
    {
	Three_Buffer,
	Three_Undo,
	0, 40, 0,
	0, 0, 0, 0, 0,
	NULL, NULL, NULL
    };

struct Gadget Three_Gadget =
    {
	&Size_Gadget,
	50, 61, 224, 8,
	GADGHCOMP,
	RELVERIFY,
	STRGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	&Three_StringInfo,
	5,
	NULL
    };

/*************** Two_Gadget ****************/

char Two_Buffer[40] = "2";
char Two_Undo[40];

struct StringInfo Two_StringInfo =
    {
	Two_Buffer,
	Two_Undo,
	0, 40, 0,
	0, 0, 0, 0, 0,
	NULL, NULL, NULL
    };

struct Gadget Two_Gadget =
    {
	&Three_Gadget,
	50, 49, 224, 8,
	GADGHCOMP,
	RELVERIFY,
	STRGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	&Two_StringInfo,
	4,
	NULL
    };

/*************** One_Gadget ****************/

char One_Buffer[40] = "/1]\\1]1";
char One_Undo[40];

struct StringInfo One_StringInfo =
    {
	One_Buffer,
	One_Undo,
	0, 40, 0,
	0, 0, 0, 0, 0,
	NULL, NULL, NULL
    };

struct Gadget One_Gadget =
    {
	&Two_Gadget,
	50, 37, 224, 8,
	GADGHCOMP,
	RELVERIFY,
	STRGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	&One_StringInfo,
	3,
	NULL
    };

/*************** Zero_Gadget ****************/

char Zero_Buffer[40] = "0/21]\\21]1";
char Zero_Undo[40];

struct StringInfo Zero_StringInfo =
    {
	Zero_Buffer,
	Zero_Undo,
	0, 40, 0,
	0, 0, 0, 0, 0,
	NULL, NULL, NULL
    };

struct Gadget Zero_Gadget =
    {
	&One_Gadget,
	50, 25, 224, 8,
	GADGHCOMP,
	RELVERIFY,
	STRGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	&Zero_StringInfo,
	2,
	NULL
    };

/*************** Init_Gadget ****************/

char Init_Buffer[40] = "01";
char Init_Undo[40];

struct StringInfo Init_StringInfo =
    {
	Init_Buffer,
	Init_Undo,
	0, 40, 0,
	0, 0, 0, 0, 0,
	NULL, NULL, NULL
    };

struct Gadget Init_Gadget =
    {
	&Zero_Gadget,
	74, 13, 200, 8,
	GADGHCOMP,
	RELVERIFY,
	STRGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	&Init_StringInfo,
	1,
	NULL
    };

